#version 150

uniform sampler2D fboTex0; 
uniform sampler2D fboTex1; 

in vec2 ex_fragTexCoord;

out vec4 out_Color;

uniform int mode;
uniform vec2 windowSize;

const int kSize = 5;
float gaussKernel[kSize];


void main(void)
{
	float I = 1;
	vec4 texColor = texture2D(fboTex0, ex_fragTexCoord);
	if(mode == 3)
	{
		out_Color = texColor;
		return;
	}
	if(mode == 0)
	{
		if(true) //texColor.x > 0.5 || texColor.y > 0.5 || texColor.z > 0.5
		{
			out_Color = texColor;
		}else{
			out_Color = vec4(0,0,0,0);
		}
		return;
	}
	vec4 blurColor = vec4(0,0,0,0);
	
	vec2 step = vec2(1.0/windowSize.x, 1.0/windowSize.y);
	
	if(kSize == 3)
	{
		gaussKernel[0] = 0.125;
		gaussKernel[1] = 0.25;
		gaussKernel[2] = 0.125;
	}
	if(kSize == 5)
	{
		gaussKernel[0] = 0.0545;
		gaussKernel[1] = 0.2442;
		gaussKernel[2] = 0.4026;
		gaussKernel[3] = 0.2442;
		gaussKernel[4] = 0.0545;
	}
//	if(kSize == 7)
//	{
//		gaussKernel[0] = 0.00038771;
//		gaussKernel[1] = 0.01330373;
//		gaussKernel[2] = 0.11098164;
//		gaussKernel[3] = 0.22508352;
//		gaussKernel[4] = 0.11098164;
//		gaussKernel[5] = 0.01330373;
//		gaussKernel[6] = 0.00038771;
	//}

	
	if(mode == 1){
	
		for(int i = 0; i < kSize; i++)
		{
			blurColor += I *  gaussKernel[i] *  texture2D(fboTex0, vec2(ex_fragTexCoord.x + (i-floor(float(kSize)/2.0))*step.x, ex_fragTexCoord.y));
		}
	}
	if(mode == 2)
	{
	
		for(int i = 0; i < kSize; i++)
		{
			blurColor += I *  gaussKernel[i] *  texture2D(fboTex0, vec2(ex_fragTexCoord.x, ex_fragTexCoord.y + (i-floor(float(kSize)/2.0)) * step.y));
		}
	}
	

out_Color = blurColor;
//if(mode==2)out_Color = blurColor * texColor;

}
