#version 150

layout(points) in;

layout(triangle_strip, max_vertices = 4) out;



uniform mat4 mvMat;
uniform mat4 projMat;



in vec3 font[1];

out vec2 texCoords;


void main(void)
{
	float m = 16; //16x16 spritesheet ascii
	
	vec4 position = gl_in[0].gl_Position;
	float size = font[0].y;
	mat4 moveMatrix;
	vec2 off;
	float shape;
	
	shape = font[0].x;
		
	off.x = float(1.0f/m) * float(mod(int(shape), int(m)));
	off.y = float(1.0f/m) * ((m-1) - float(floor(shape/m)));
	

	moveMatrix[0] = vec4(1.0, 0.0, 0.0, 0.0);
	moveMatrix[1] = vec4(0.0, 1.0, 0.0, 0.0);
	moveMatrix[2] = vec4(0.0, 0.0, 1.0, 0.0);
	moveMatrix[3] = vec4(0.0, 0.0, 0.0, 1.0);
	
	
	moveMatrix[3] = vec4(-size/2, -size/2, 0, 1);
	gl_Position = projMat * mvMat * moveMatrix  * position;
	texCoords = vec2(0 + off.x, -1*(0 + off.y));
	EmitVertex();
	
	moveMatrix[3] = vec4(size/2, -size/2, 0, 1);
	gl_Position = projMat * mvMat * moveMatrix *  position;
	texCoords = vec2(1.0f/m + off.x, -1*(0 + off.y));
	EmitVertex();
	
	
	moveMatrix[3] = vec4(-size/2, size/2, 0, 1);
	gl_Position = projMat * mvMat * moveMatrix *position;
	texCoords = vec2(0 + off.x, -1*(1.0f/m + off.y));
	EmitVertex();	
	
	moveMatrix[3] = vec4(size/2, size/2, 0, 1);
	gl_Position = projMat * mvMat * moveMatrix * position;
	texCoords = vec2(1.0f/m + off.x, -1*(1.0f/m + off.y));
	EmitVertex();


	EndPrimitive();
    


}
