#version 150



in  vec4 lightScreenCoords;
in	vec4 lightWorldCoords;
in	vec2 ex_fragTexCoord;


out vec4 out_Color;

uniform sampler2D fboTex0; 
uniform vec2 windowSize;

const int NUM_SAMPLES = 70;

void main(void)
{

	vec4 sample;
	
	float exposure = 0.0034f;
	float decay = 1.0f;
	float density = 0.74f;
	float weight = 7.65f;
	

	vec2 screenCoords = ex_fragTexCoord;
	vec2 step = vec2(screenCoords - (lightScreenCoords.st/lightScreenCoords.w));
	//if(lightWorldCoords.z > 0) step = vec2(screenCoords + (lightScreenCoords.st/lightScreenCoords.w));
	step *= 1.0/ float(NUM_SAMPLES) * density;
	
	for(int i = 0; i< NUM_SAMPLES; i++)
	{
		screenCoords -= step;
		sample = texture2D(fboTex0, screenCoords);
		out_Color += sample * weight;
	}
	out_Color *= exposure;
	out_Color.a = 1;

}
