#version 150


in	vec2 ex_fragTexCoord;


out vec4 out_Color;

uniform sampler2D fboTex0;
uniform sampler2D fboTex1; 

//uniform vec2 windowSize;
uniform mat4 invProjMat;
uniform mat4 invViewMat;
uniform mat4 viewMatOld;
uniform mat4 projMat;
uniform mat4 vMat;

const int NUM_SAMPLES = 20;

void main(void)
{
	vec2 texCoord = ex_fragTexCoord;
	//mat4 invProjViewMat = invViewMat * invProjMat;
	
	//get depth value and calculate curr pos
	float depthValue = texture(fboTex1, texCoord).r;
	vec4 currPos = vec4(texCoord.x * 2.0f - 1.0f, (1.0f-texCoord.y) * 2.0f - 1.0f, depthValue, 1.0f);
	
	//get world pos
	vec4 worldPos = invViewMat * invProjMat * currPos;
	worldPos /= worldPos.w;
	
	//calculate old world pos screen coords
	vec4 oldPos =  projMat * viewMatOld * worldPos;	
	oldPos /= oldPos.w;
	
	//vec4 currPos2 = projMat * vMat * worldPos;
	//currPos2 /= currPos.w;
	//currPos2.x = -currPos2.x;
	//currPos2.y = -currPos2.y;
	
	
	vec2 velocity = ((currPos - oldPos)/2.0f).xy;
	velocity = velocity / NUM_SAMPLES;
	
	vec4 color = texture(fboTex0, texCoord);
	
	texCoord += velocity;
	for(int i = 1; i < NUM_SAMPLES; i++)
	{
		color += texture(fboTex0, texCoord);
		texCoord += velocity;
	}
	
	out_Color = color/NUM_SAMPLES;
	



// if(oldPos.x < 0 && oldPos.y < 0)out_Color = vec4(1,0,0,1); //top left RED
// if(oldPos.x > 0 && oldPos.y < 0)out_Color = vec4(0,1,0,1); //top right GREEN
 //if(oldPos.x > 0 && oldPos.y > 0)out_Color = vec4(0,0,1,1); //bottom right BLUE
 //if(oldPos.x < 0 && oldPos.y > 0)out_Color = vec4(1,1,1,1); //bottom left WHITE
 //out_Color = vec4(depthValue, depthValue, depthValue,1);

//if(depthValue < 1.0) out_Color = vec4(1,0,0,1);
//if(depthValue < 0.83 && depthValue > 0.82) out_Color = vec4(1,1,0,1);
//if(depthValue < 0.8) out_Color = vec4(0,1,0,1);
//if(depthValue < 0.7) out_Color = vec4(1,0,1,1);
//if(depthValue < 0.6) out_Color = vec4(0,1,1,1);
//if(depthValue < 0.5) out_Color = vec4(1,1,1,1);
//if(depthValue < 0.4) out_Color = vec4(1,0,0,1);

//out_Color = currPos2;
//out_Color.z = 0.0f;
//out_Color.w = 1.0f;
}
