// Vertex Shader Ã¢â‚¬â€œ file "base.vert"

#version 150


in  vec3 in_Position;
in	vec3 in_Position_Target;


in	vec2 in_TexCoord;

out vec2 ex_fragTexCoord;


	
uniform mat4 mvMat;
uniform mat4 projMat;


uniform int mode;
uniform int interpolate;
uniform float dt;



void main(void)
{


	vec3 position;
	if(interpolate == 1)
	{
		position.x = (1-dt) * in_Position.x + dt * in_Position_Target.x;
		position.y = (1-dt) * in_Position.y + dt * in_Position_Target.y;
		position.z = (1-dt) * in_Position.z + dt * in_Position_Target.z;
	}
	else
	{
		position = in_Position;
	}
	
	
	
	ex_fragTexCoord.x = in_TexCoord.x;
	ex_fragTexCoord.y = -1 * in_TexCoord.y;

	//position calculation
	gl_Position = projMat *  mvMat * vec4(position,1);
	
}
